--- a/src/HOL/IsaMakefile Mon Jan 23 17:40:31 2012 +0100
+++ b/src/HOL/IsaMakefile Mon Jan 23 17:40:31 2012 +0100
@@ -334,8 +334,8 @@
Tools/Nitpick/nitpick_rep.ML \
Tools/Nitpick/nitpick_scope.ML \
Tools/Nitpick/nitpick_tests.ML \
+ Tools/Nitpick/nitpick_tptp.ML \
Tools/Nitpick/nitpick_util.ML \
- Tools/Nitpick/nitrox.ML \
Tools/numeral.ML \
Tools/numeral_simprocs.ML \
Tools/numeral_syntax.ML \
--- a/src/HOL/Nitpick.thy Mon Jan 23 17:40:31 2012 +0100
+++ b/src/HOL/Nitpick.thy Mon Jan 23 17:40:31 2012 +0100
@@ -23,11 +23,11 @@
("Tools/Nitpick/nitpick_model.ML")
("Tools/Nitpick/nitpick.ML")
("Tools/Nitpick/nitpick_isar.ML")
+ ("Tools/Nitpick/nitpick_tptp.ML")
("Tools/Nitpick/nitpick_tests.ML")
- ("Tools/Nitpick/nitrox.ML")
begin
-typedecl iota (* for Nitrox *)
+typedecl iota (* for TPTP *)
typedecl bisim_iterator
axiomatization unknown :: 'a
@@ -223,8 +223,8 @@
use "Tools/Nitpick/nitpick_model.ML"
use "Tools/Nitpick/nitpick.ML"
use "Tools/Nitpick/nitpick_isar.ML"
+use "Tools/Nitpick/nitpick_tptp.ML"
use "Tools/Nitpick/nitpick_tests.ML"
-use "Tools/Nitpick/nitrox.ML"
setup {*
Nitpick_Isar.setup #>
--- a/src/HOL/TPTP/lib/Tools/nitrox Mon Jan 23 17:40:31 2012 +0100
+++ /dev/null Thu Jan 01 00:00:00 1970 +0000
@@ -1,28 +0,0 @@
-#!/usr/bin/env bash
-#
-# Author: Jasmin Blanchette
-#
-# DESCRIPTION: TPTP FOF version of Nitpick
-
-
-PRG="$(basename "$0")"
-
-function usage() {
- echo
- echo "Usage: isabelle $PRG FILES"
- echo
- echo " Runs Nitrox on a CNF or FOF TPTP problem."
- echo
- exit 1
-}
-
-[ "$#" -eq 0 -o "$1" = "-?" ] && usage
-
-SCRATCH="Scratch_${PRG}_$$_${RANDOM}"
-
-for FILE in "$@"
-do
- echo "theory $SCRATCH imports \"Nitpick\" begin ML {* Nitrox.pick_nits_in_fof_file \"$FILE\" *} end;" \
- > /tmp/$SCRATCH.thy
- "$ISABELLE_PROCESS" -e "use_thy \"/tmp/$SCRATCH\"; exit 1;"
-done
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/src/HOL/TPTP/lib/Tools/tptp_isabelle Mon Jan 23 17:40:31 2012 +0100
@@ -0,0 +1,28 @@
+#!/usr/bin/env bash
+#
+# Author: Jasmin Blanchette
+#
+# DESCRIPTION: Isabelle tactics for TPTP
+
+
+PRG="$(basename "$0")"
+
+function usage() {
+ echo
+ echo "Usage: isabelle $PRG FILES"
+ echo
+ echo " Runs a combination of Isabelle tactics on TPTP problems."
+ echo
+ exit 1
+}
+
+[ "$#" -eq 0 -o "$1" = "-?" ] && usage
+
+SCRATCH="Scratch_${PRG}_$$_${RANDOM}"
+
+for FILE in "$@"
+do
+ echo "theory $SCRATCH imports \"CASC\_Setup\" begin ML {* FIXME \"$FILE\" *} end;" \
+ > /tmp/$SCRATCH.thy
+ "$ISABELLE_PROCESS" -e "use_thy \"/tmp/$SCRATCH\"; exit 1;"
+done
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/src/HOL/TPTP/lib/Tools/tptp_nitpick Mon Jan 23 17:40:31 2012 +0100
@@ -0,0 +1,28 @@
+#!/usr/bin/env bash
+#
+# Author: Jasmin Blanchette
+#
+# DESCRIPTION: Nitpick for TPTP
+
+
+PRG="$(basename "$0")"
+
+function usage() {
+ echo
+ echo "Usage: isabelle $PRG FILES"
+ echo
+ echo " Runs Nitpick on TPTP problems."
+ echo
+ exit 1
+}
+
+[ "$#" -eq 0 -o "$1" = "-?" ] && usage
+
+SCRATCH="Scratch_${PRG}_$$_${RANDOM}"
+
+for FILE in "$@"
+do
+ echo "theory $SCRATCH imports \"Main\" begin ML {* Nitpick_TPTP.pick_nits_in_tptp_file \"$FILE\" *} end;" \
+ > /tmp/$SCRATCH.thy
+ "$ISABELLE_PROCESS" -e "use_thy \"/tmp/$SCRATCH\"; exit 1;"
+done
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/src/HOL/TPTP/lib/Tools/tptp_refute Mon Jan 23 17:40:31 2012 +0100
@@ -0,0 +1,28 @@
+#!/usr/bin/env bash
+#
+# Author: Jasmin Blanchette
+#
+# DESCRIPTION: Refute for TPTP
+
+
+PRG="$(basename "$0")"
+
+function usage() {
+ echo
+ echo "Usage: isabelle $PRG FILES"
+ echo
+ echo " Runs Refute on TPTP problems."
+ echo
+ exit 1
+}
+
+[ "$#" -eq 0 -o "$1" = "-?" ] && usage
+
+SCRATCH="Scratch_${PRG}_$$_${RANDOM}"
+
+for FILE in "$@"
+do
+ echo "theory $SCRATCH imports \"Main\" begin ML {* Refute.refute_tptp_file \"$FILE\" *} end;" \
+ > /tmp/$SCRATCH.thy
+ "$ISABELLE_PROCESS" -e "use_thy \"/tmp/$SCRATCH\"; exit 1;"
+done
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/src/HOL/TPTP/lib/Tools/tptp_sledgehammer Mon Jan 23 17:40:31 2012 +0100
@@ -0,0 +1,28 @@
+#!/usr/bin/env bash
+#
+# Author: Jasmin Blanchette
+#
+# DESCRIPTION: Sledgehammer for TPTP
+
+
+PRG="$(basename "$0")"
+
+function usage() {
+ echo
+ echo "Usage: isabelle $PRG FILES"
+ echo
+ echo " Runs Sledgehammer on TPTP problems."
+ echo
+ exit 1
+}
+
+[ "$#" -eq 0 -o "$1" = "-?" ] && usage
+
+SCRATCH="Scratch_${PRG}_$$_${RANDOM}"
+
+for FILE in "$@"
+do
+ echo "theory $SCRATCH imports \"Main\" begin ML {* Sledgehammer_Isar.run_sledgehammer_on_tptp_file \"$FILE\" *} end;" \
+ > /tmp/$SCRATCH.thy
+ "$ISABELLE_PROCESS" -e "use_thy \"/tmp/$SCRATCH\"; exit 1;"
+done
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/src/HOL/TPTP/lib/Tools/tptp_translate Mon Jan 23 17:40:31 2012 +0100
@@ -0,0 +1,28 @@
+#!/usr/bin/env bash
+#
+# Author: Jasmin Blanchette
+#
+# DESCRIPTION: Translation tool for TPTP formats
+
+
+PRG="$(basename "$0")"
+
+function usage() {
+ echo
+ echo "Usage: isabelle $PRG FORMAT FILE"
+ echo
+ echo " Translates TPTP file to specified TPTP format (\"CNF\", \"FOF\", \"TFF0\", \"TFF1\", or \"THF0\")."
+ echo
+ exit 1
+}
+
+[ "$#" -eq 0 -o "$1" = "-?" ] && usage
+
+SCRATCH="Scratch_${PRG}_$$_${RANDOM}"
+
+for FILE in "$@"
+do
+ echo "theory $SCRATCH imports \"Main\" begin ML {* ATP_Translate.translate_tptp_file \"$FILE\" *} end;" \
+ > /tmp/$SCRATCH.thy
+ "$ISABELLE_PROCESS" -e "use_thy \"/tmp/$SCRATCH\"; exit 1;"
+done
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/src/HOL/Tools/Nitpick/nitpick_tptp.ML Mon Jan 23 17:40:31 2012 +0100
@@ -0,0 +1,140 @@
+(* Title: HOL/Tools/Nitpick/nitpick_tptp.ML
+ Author: Jasmin Blanchette, TU Muenchen
+ Copyright 2010, 2011
+
+Nitpick for TPTP.
+*)
+
+signature NITPICK_TPTP =
+sig
+ val pick_nits_in_tptp_file : string -> string
+end;
+
+structure Nitpick_TPTP : NITPICK_TPTP =
+struct
+
+open ATP_Util
+open ATP_Problem
+open ATP_Proof
+open Nitpick_Util
+open Nitpick
+open Nitpick_Isar
+
+exception SYNTAX of string
+
+val tptp_explode = raw_explode o strip_spaces_except_between_idents
+
+fun parse_file_path (c :: ss) =
+ if c = "'" orelse c = "\"" then
+ ss |> chop_while (curry (op <>) c) |>> implode ||> tl
+ else
+ raise SYNTAX "invalid file path"
+ | parse_file_path [] = raise SYNTAX "invalid file path"
+
+fun parse_include x =
+ let
+ val (file_name, rest) =
+ (Scan.this_string "include" |-- $$ "(" |-- parse_file_path --| $$ ")"
+ --| $$ ".") x
+ val path = file_name |> Path.explode
+ val path =
+ path |> not (Path.is_absolute path) ? Path.append (Path.explode "$TPTP")
+ in ((), (path |> File.read |> tptp_explode) @ rest) end
+
+val parse_cnf_or_fof =
+ (Scan.this_string "cnf" || Scan.this_string "fof") |-- $$ "(" |--
+ Scan.many (not_equal ",") |-- $$ "," |--
+ (Scan.this_string "axiom" || Scan.this_string "definition"
+ || Scan.this_string "theorem" || Scan.this_string "lemma"
+ || Scan.this_string "hypothesis" || Scan.this_string "conjecture"
+ || Scan.this_string "negated_conjecture") --| $$ "," -- parse_formula
+ --| $$ ")" --| $$ "."
+ >> (fn ("conjecture", phi) => AConn (ANot, [phi]) | (_, phi) => phi)
+
+val parse_problem =
+ Scan.repeat parse_include
+ |-- Scan.repeat (parse_cnf_or_fof --| Scan.repeat parse_include)
+
+val parse_tptp_problem =
+ Scan.finite Symbol.stopper
+ (Scan.error (!! (fn _ => raise SYNTAX "malformed TPTP input")
+ parse_problem))
+ o tptp_explode
+
+val iota_T = @{typ iota}
+val quant_T = (iota_T --> bool_T) --> bool_T
+
+fun is_variable s = Char.isUpper (String.sub (s, 0))
+
+fun hol_term_from_fo_term res_T (ATerm (x, us)) =
+ let val ts = map (hol_term_from_fo_term iota_T) us in
+ list_comb ((case x of
+ "$true" => @{const_name True}
+ | "$false" => @{const_name False}
+ | "=" => @{const_name HOL.eq}
+ | "equal" => @{const_name HOL.eq}
+ | _ => x, map fastype_of ts ---> res_T)
+ |> (if is_variable x then Free else Const), ts)
+ end
+
+fun hol_prop_from_formula phi =
+ case phi of
+ AQuant (_, [], phi') => hol_prop_from_formula phi'
+ | AQuant (q, (x, _) :: xs, phi') =>
+ Const (case q of AForall => @{const_name All} | AExists => @{const_name Ex},
+ quant_T)
+ $ lambda (Free (x, iota_T)) (hol_prop_from_formula (AQuant (q, xs, phi')))
+ | AConn (ANot, [u']) => HOLogic.mk_not (hol_prop_from_formula u')
+ | AConn (c, [u1, u2]) =>
+ pairself hol_prop_from_formula (u1, u2)
+ |> (case c of
+ AAnd => HOLogic.mk_conj
+ | AOr => HOLogic.mk_disj
+ | AImplies => HOLogic.mk_imp
+ | AIff => HOLogic.mk_eq
+ | ANot => raise Fail "binary \"ANot\"")
+ | AConn _ => raise Fail "malformed AConn"
+ | AAtom u => hol_term_from_fo_term bool_T u
+
+fun mk_all x t = Const (@{const_name All}, quant_T) $ lambda x t
+
+fun close_hol_prop t = fold (mk_all o Free) (Term.add_frees t []) t
+
+fun pick_nits_in_tptp_file file_name =
+ case parse_tptp_problem (File.read (Path.explode file_name)) of
+ (_, s :: ss) => raise SYNTAX ("cannot parse " ^ quote (implode (s :: ss)))
+ | (phis, []) =>
+ let
+ val ts = map (HOLogic.mk_Trueprop o close_hol_prop
+ o hol_prop_from_formula) phis
+(*
+ val _ = warning (PolyML.makestring phis)
+ val _ = app (warning o Syntax.string_of_term @{context}) ts
+*)
+ val state = Proof.init @{context}
+ val params =
+ [("card iota", "1\<emdash>100"),
+ ("card", "1\<emdash>8"),
+ ("box", "false"),
+ ("sat_solver", "smart"),
+ ("max_threads", "1"),
+ ("batch_size", "10"),
+ (* ("debug", "true"), *)
+ ("verbose", "true"),
+ (* ("overlord", "true"), *)
+ ("show_consts", "true"),
+ ("format", "1000"),
+ ("max_potential", "0"),
+ ("timeout", "none"),
+ ("expect", genuineN)]
+ |> default_params @{theory}
+ val i = 1
+ val n = 1
+ val step = 0
+ val subst = []
+ in
+ pick_nits_in_term state params Normal i n step subst ts @{prop False}
+ |> fst
+ end
+
+end;
--- a/src/HOL/Tools/Nitpick/nitrox.ML Mon Jan 23 17:40:31 2012 +0100
+++ /dev/null Thu Jan 01 00:00:00 1970 +0000
@@ -1,140 +0,0 @@
-(* Title: HOL/Tools/Nitpick/nitrox.ML
- Author: Jasmin Blanchette, TU Muenchen
- Copyright 2010, 2011
-
-Finite model generation for TPTP first-order formulas (FOF and CNF) via Nitpick.
-*)
-
-signature NITROX =
-sig
- val pick_nits_in_fof_file : string -> string
-end;
-
-structure Nitrox : NITROX =
-struct
-
-open ATP_Util
-open ATP_Problem
-open ATP_Proof
-open Nitpick_Util
-open Nitpick
-open Nitpick_Isar
-
-exception SYNTAX of string
-
-val tptp_explode = raw_explode o strip_spaces_except_between_idents
-
-fun parse_file_path (c :: ss) =
- if c = "'" orelse c = "\"" then
- ss |> chop_while (curry (op <>) c) |>> implode ||> tl
- else
- raise SYNTAX "invalid file path"
- | parse_file_path [] = raise SYNTAX "invalid file path"
-
-fun parse_include x =
- let
- val (file_name, rest) =
- (Scan.this_string "include" |-- $$ "(" |-- parse_file_path --| $$ ")"
- --| $$ ".") x
- val path = file_name |> Path.explode
- val path =
- path |> not (Path.is_absolute path) ? Path.append (Path.explode "$TPTP")
- in ((), (path |> File.read |> tptp_explode) @ rest) end
-
-val parse_fof_or_cnf =
- (Scan.this_string "fof" || Scan.this_string "cnf") |-- $$ "(" |--
- Scan.many (not_equal ",") |-- $$ "," |--
- (Scan.this_string "axiom" || Scan.this_string "definition"
- || Scan.this_string "theorem" || Scan.this_string "lemma"
- || Scan.this_string "hypothesis" || Scan.this_string "conjecture"
- || Scan.this_string "negated_conjecture") --| $$ "," -- parse_formula
- --| $$ ")" --| $$ "."
- >> (fn ("conjecture", phi) => AConn (ANot, [phi]) | (_, phi) => phi)
-
-val parse_problem =
- Scan.repeat parse_include
- |-- Scan.repeat (parse_fof_or_cnf --| Scan.repeat parse_include)
-
-val parse_tptp_problem =
- Scan.finite Symbol.stopper
- (Scan.error (!! (fn _ => raise SYNTAX "malformed TPTP input")
- parse_problem))
- o tptp_explode
-
-val iota_T = @{typ iota}
-val quant_T = (iota_T --> bool_T) --> bool_T
-
-fun is_variable s = Char.isUpper (String.sub (s, 0))
-
-fun hol_term_from_fo_term res_T (ATerm (x, us)) =
- let val ts = map (hol_term_from_fo_term iota_T) us in
- list_comb ((case x of
- "$true" => @{const_name True}
- | "$false" => @{const_name False}
- | "=" => @{const_name HOL.eq}
- | "equal" => @{const_name HOL.eq}
- | _ => x, map fastype_of ts ---> res_T)
- |> (if is_variable x then Free else Const), ts)
- end
-
-fun hol_prop_from_formula phi =
- case phi of
- AQuant (_, [], phi') => hol_prop_from_formula phi'
- | AQuant (q, (x, _) :: xs, phi') =>
- Const (case q of AForall => @{const_name All} | AExists => @{const_name Ex},
- quant_T)
- $ lambda (Free (x, iota_T)) (hol_prop_from_formula (AQuant (q, xs, phi')))
- | AConn (ANot, [u']) => HOLogic.mk_not (hol_prop_from_formula u')
- | AConn (c, [u1, u2]) =>
- pairself hol_prop_from_formula (u1, u2)
- |> (case c of
- AAnd => HOLogic.mk_conj
- | AOr => HOLogic.mk_disj
- | AImplies => HOLogic.mk_imp
- | AIff => HOLogic.mk_eq
- | ANot => raise Fail "binary \"ANot\"")
- | AConn _ => raise Fail "malformed AConn"
- | AAtom u => hol_term_from_fo_term bool_T u
-
-fun mk_all x t = Const (@{const_name All}, quant_T) $ lambda x t
-
-fun close_hol_prop t = fold (mk_all o Free) (Term.add_frees t []) t
-
-fun pick_nits_in_fof_file file_name =
- case parse_tptp_problem (File.read (Path.explode file_name)) of
- (_, s :: ss) => raise SYNTAX ("cannot parse " ^ quote (implode (s :: ss)))
- | (phis, []) =>
- let
- val ts = map (HOLogic.mk_Trueprop o close_hol_prop
- o hol_prop_from_formula) phis
-(*
- val _ = warning (PolyML.makestring phis)
- val _ = app (warning o Syntax.string_of_term @{context}) ts
-*)
- val state = Proof.init @{context}
- val params =
- [("card iota", "1\<emdash>100"),
- ("card", "1\<emdash>8"),
- ("box", "false"),
- ("sat_solver", "smart"),
- ("max_threads", "1"),
- ("batch_size", "10"),
- (* ("debug", "true"), *)
- ("verbose", "true"),
- (* ("overlord", "true"), *)
- ("show_consts", "true"),
- ("format", "1000"),
- ("max_potential", "0"),
- ("timeout", "none"),
- ("expect", genuineN)]
- |> default_params @{theory}
- val i = 1
- val n = 1
- val step = 0
- val subst = []
- in
- pick_nits_in_term state params Normal i n step subst ts @{prop False}
- |> fst
- end
-
-end;